/*------------------------------------------------------------------------------*
 * Architecture & Implementation of DBMS                                        *
 *------------------------------------------------------------------------------*
 * Copyright 2019 Databases and Information Systems Group TU Dortmund          *
 *                                                                              *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS      *
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL      *
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR         *
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,        *
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR        *
 * OTHER DEALINGS IN THE SOFTWARE.                                              *
 *------------------------------------------------------------------------------*
 */

// TODO: If you want to use your B+ tree implementation you have to include the header files
// #include "index/b_plus_tree.h"

#include <unordered_map>
#include "operators/index_nested_loops_join.h"

Relation aidbms::operators::IndexNestedLoopsJoin::join(const Relation& r, const Relation& s, Predicate p)
{
    Relation t (r,s);
    const auto r_attr = r.columnIndex(p.left);
    const auto s_attr = s.columnIndex(p.right);
    
    // TODO: If you have implemented the b+ tree you can use it instead of the hashindex 
    //aidbms::index::BPlusTree<VALUE_TYPE, Tuple> b_plus_tree;
    std::unordered_map<VALUE_TYPE, Tuple> hash_table;
    
    // TODO: Implement the index nested loops join here!

    return t;
}
